--- old/usr/src/lib/libm/common/m9x/fmaxf.c	2014-05-04 03:06:36.918424451 +0200
+++ new/usr/src/lib/libm/common/m9x/fmaxf.c	2014-05-04 03:06:36.949437226 +0200
@@ -127,17 +127,12 @@
 	if (x != x)
 		x = y;
 
-	/* if x is less than y or x and y are unordered, replace x by y */
-#if defined(COMPARISON_MACRO_BUG)
-	if (x < y)
-#else
-	if (!isgreaterequal(x, y))
-#endif
+	/* At this point, x and y are either both numeric, or both NaN */
+	if (!isnan(x) && !isgreaterequal(x, y))
 		x = y;
 
 	/*
-	 * now x and y are either both NaN or both numeric; clear the
-	 * sign of the result if either x or y has its sign clear
+	 * clear the sign of the result if either x or y has its sign clear
 	 */
 	xx.f = x;
 	yy.f = y;
